<?
/* MANIPULAO DE DATAS e HORAS
date - Formata a data e a hora local

Descrio
string date ( string format [, int timestamp] )

Retorna uma string de acordo com a string format dada usando o inteiro timestamp dado ou a hora atual local se nenhum timestamp  dado. Em outras palavras, timestamp  opcional e o padro para o valor de time().
Nota: A linha vlida de um timestamp  tipicamente de Fri, 13 Dec 1901 20:45:54 GMT to Tue, 19 Jan 2038 03:14:07 GMT. (Estas so as datas que correspodem aos mnimos e mximos valores para um inteiro de 32-bit definido). No windows esta linha  limitada de 01-01-1970 para 19-01-2038. 
Nota: Para gerar um timestamp a partir de uma representao de string da data, voc deve ser capaz de usar strtotime(). Adicionalmente, alguns bancos de dados tm funes para converter suas datas em timestamps (tais como a funo do MySQL UNIX_TIMESTAMP). 

Os seguintes caracteres so reconhecidos no format parameter string
format character	Descrio	Exemplo de valores retornados
a	Lowercase Ante meridiem and Post meridiem	am or pm
A	Uppercase Ante meridiem and Post meridiem	AM ou PM
B	Swatch Internet time	000 at 999
d	Dia do ms, 2 digitos com leading zeros	01 to 31
D	Uma representao textual de um dia, trs letras	Mon through Sun
F	Uma representao textual de um ms, tal como janeiro ou Maro	Janeiro a Dezembro
g	12-hour formato de hora sem leading zeros	1 a 12
G	24-hour formato de hora sem leading zeros	0 a 23
h	12-hour formato de hora com leading zeros	01 a 12
H	24-hour formato de hora com leading zeros	00 a 23
i	Minutos com leading zeros	00 para 59
I 	(i maisculo)	Se a data est ou no em horrio de vero 1 Horrio de Vero, 0 sem Horrio de Vero.
j	Dia do ms sem leading zeros 1 to 31
l 	('L' minsculo)Uma representao completa textual de um dia da semana	Domingo a Sbado
L	Se  ano bissexto 1 ano bissexto, 0 ano no bissexto.
m	Representao numrica de um ms, com leading zeros	01 a 12
M	Uma representao textual curta de um ms, trs letras	Jan a Dec
n	Representao numrica de um ms, sem leading zeros	1 a 12
O	Diferena ao horrio de Greenwich (GMT) em horas	Exemplo: +0200
r	RFC 2822 formatted date	Exemplo: Thu, 21 Dec 2000 16:01:07 +0200
s	Segundos, com leading zeros	00 a 59
S	Sufixo ordinal ingls para o dia do ms, 2 caracteres	st, nd, rd ou th. Funciona bem com j
t	Nmero de dias do dado ms	28 a 31
T	Timezone setting of this machine	Examples: EST, MDT ...
U	Seconds since the Unix Epoch (January 1 1970 00:00:00 GMT)	See also time()
w	Representao numrica do dia da semana	0 (para Domingo) a 6 (para Sbado)
W	Nmero da semana do ano ISO-8601, semanas comeadas na segunda-feira (adicionado no PHP 4.1.0)	Exemplo: 42 (a 42nd (quadragsima segunda) semana do ano)
Y	Uma representao completa do ano, 4 dgitos	Examples: 1999 ou 2003
y	Representao do ano em dois dgitos	Examples: 99 ou 03
z	O dia do ano (comeando de 0)	0 a 365

Caracteres no reconhecidos no formato de sero impressos como so. 
O formato Z ser sempre retornado 0 quando usar gmdate().
*/
echo "<br><br>Exibindo Horas:<br>";
$hora=date("H:i:s");
echo $hora;

/* getdate - Consegue informaes data/hora

array getdate ( [int timestamp] )
Retorna um array associativo contendo a informao da data do timestamp, ou a hora corrente local se nenhum timestamp  dado,como a seguintes elementos do array:

Chave	    Descrio	                        Exemplo dos valores retornados
"seconds"	Representao numrica dos segundos	0 a 59
"minutes"	Representao numrica dos minutos	0 a 59
"hours"		Representao numrica das horas	0 a 23
"mday"		Representao numrica do dia do ms	1 a 31
"wday"		Representao numrica do dia da semana	0 (para Sunday) a 6 (para Saturday)
"mon"		Representao numrica de um ms	1 a 12
"year"		Representao numrica completa do ano, 4 digitos	Exemples: 1999 ou 2003
"yday"		Representao numerica do dia do ano	0 a 366
"weekday"	Representao textual completa do dia da semana	Sunday a Saturday
"month"		Representao textual completa de um ms, tal como January ou March	January a December

0 segundos desde a poca UNIX, similar aos valores retornados por by time() e usados por date(). System Dependent, tipicamente de -2147483648 a 2147483647.
A sada ser similar a:

Array
(
    [seconds] => 40
    [minutes] => 58
    [hours]   => 21
    [mday]    => 17
    [wday]    => 2
    [mon]     => 6
    [year]    => 2003
    [yday]    => 167
    [weekday] => Tuesday
    [month]   => June
    [0]       => 1055901520
)
*/
echo "<br><br>Usando o GETDATE:<br>";
$today = getdate();
//echo $today;
echo "<br>".$today[year];
echo "<br>".$today[weekday];


echo "<br><br> Data em portugues:<br>";
$mes["01"] = "Janeiro";
$mes["02"] = "Fevereiro";
$mes["03"] = "Maro";
$mes["04"] = "Abril";
$mes["05"] = "Maio";
$mes["06"] = "Junho";
$mes["07"] = "Julho";
$mes["08"] = "Agosto";
$mes["09"] = "Setembro";
$mes["10"] = "Outubro";
$mes["11"] = "Novembro";
$mes["12"] = "Dezembro";

$diasemana["0"] = "Domingo";
$diasemana["1"] = "Segunda-feira";
$diasemana["2"] = "Tera-feira";
$diasemana["3"] = "Quarta-feira";
$diasemana["4"] = "Quinta-feira";
$diasemana["5"] = "Sexta-feira";
$diasemana["6"] = "Sabado";

$dia = date('d'); //Retorna o dia
$diasemanan = date('w'); //Retorna o dia da semana
$mesn = date('m'); //Retorna o ms
$ano = date('Y'); //Retorna o ano

echo "$diasemana[$diasemanan]"." Dia:".$dia." de ".$mes[$mesn]." de".$ano;
echo "<br><br>Validar Data:<br>";


//Funo valida data
function ValidaData($dat)
{
/*
explode() Tem por finalidade dividir uma string em strings.
ex: explode("/","10/02/1999")
Utiliza o / como separador e divide a string em 3 partes.
*/
	$data = explode("/","$dat");
	$d = $data[0];
	$m = $data[1];
	$y = $data[2];


/*
checkdate - Validar uma data Gregoriana
bool checkdate ( int ms, int dia, int ano )

Retorna TRUE se a data dada  vlida; caso contrrio retorna FALSE. 
Checa a validade da data formada pelos argumentos. Uma data  considerada vlida se:
	O ano est entre 1 e 32767
	O ms est entre 1 e 12
    O dia deve estar dentro do nmero de dias permitidos para o dado ms. 
anos bissextos so levados em considerao. 
*/
	$res = checkdate($m,$d,$y);
	if ($res == 1)
	{
	   echo "data ok!";
	} 
	else 
	{
	   echo "data invlida!";
	}
}

//Exemplo de chamada a funo
ValidaData("19/05/1979");

//1979/05/19
//Calculo com datas

echo "<br><br>Calculo com Data:<br>";
function adicionaDia($data,$dias) 
{
     $ano = substr ( $data, 0, 4 );
     $mes= substr ( $data, 4, 2 );
     $dia=  substr ( $data, 6, 2 );
     $proxdia= mktime ( 0, 0, 0, $mes, $dia+ $dias, $ano);
     return strftime("%Y%m%d", $proxdia);
}

/*
mktime - Obtm um timestamp Unix para uma data

int mktime ( [int hora [, int minuto [, int second [, int mes [, int dia [, int ano [, int is_dst]]]]]]] )

Ateno: Note a estranha ordem dos argumentos, que diferem da ordem dos argumentos em uma chamada regular da UNIX mktime() e que no combina bem omitir os parmetros da direita para a esquerda (veja abaixo). 
 um erro comum misturar estes valores acima em um script.
Retorna o timestamp Unix correspondente para os argumentos dados. 
Este timestamp  um longo inteiro contendo o nmero de segundos entre a Era Unix (January 1 1970) e o tempo especificado.
Argumentos podem ser omitidos da direita para esquerda; quaisquer argumentos assim omitidos sero definidos para o valor atual de acordo com a data e a hora local.

is_dst pode ser definido para 1 se est durante o horrio de vero, 0 se no estiver, ou -1 (o padro) se no se sabe se est em horrio de vero ou no. Se  desconhecido, o PHP tenta calcular. Isto pode causar resultados inesperados (mas no incorretos).

mktime()  til durante a aritmtica e validao de data, enquanto ela calcular automaticamente o valor correto para a entrada out-of-range. Por exemplo, cada uma das seguintes linhas produzir a string "Jan-01-1998"
*/

/*
strftime -  Formata uma hora/data de acordo com as configuraes locais

string strftime ( string format [, int timestamp] )

Retorna uma string formatada de acordo com o formato dado em timestamp ou o horrio corrente se nenhum timestamp  dado. 
Nomes de ms e dia da semana e outras strings dependentes de linguagens respeitam o a localidade definida com setlocale().
As seguintes converses especificadoras so conhecidas no formato de string:
	
    %a - dia da semana abreviado de acordo com a localidade
    %A - nome da semana completo de acordo com a localidade
    %b - nome do ms abreviado de acordo com a localidade
    %B - nome do ms completo de acordo com a localidade
    %c - representao da data e hora preferida pela a localidade
    %C - nmero do sculo (o ano dividido por 100 e truncado para um inteiro, de 00 at 99)
    %d - dia do ms como um nmero decimal (de 01 at 31)
    %D - mesmo que %m/%d/%y
    %e - dia do ms como um nmero decimal, um simples dgito  precedido por espao (de ' 1' at '31')
    %g - como %G, mas sem o sculo.
    %G - o 4-dgito do ano correspodendo as ISO week number (see %V). Este tem o mesmo formato e valor que %Y, exceto que se o ISO week number pertence ao prvio ou prximo ano, aquele ano  usado ao invs deste.
    %h - mesmo que %b
    %H - hora como um nmero decimal usando um relgio de 24-horas (de 00 at 23)
    %I - hora como um nmero decimal usando um relgio de 12-hoas (de 01 at 12)
    %j - dia do ano como nmero decimal (de 001 at 366)
    %m - ms como nmero decimal (de 01 at 12)
    %M - minuto como nmero decimal
    %n - caracter novalinha
    %p - um dos dois `am' ou `pm' de acordo com o valor da hora dada, ou as strings correspondentes para a localidade
    %r - hora em a.m. e p.m. notao
    %R - hora em notao de 24 horas
    %S - segundo como um nmero decimal
    %t - caracter tab
    %T - hora corrente, igual a %H:%M:%S
    %u - dia da semana como nmero decimal [1,7], com 1 representando Segunda-feira

Ateno
Sun Solaris parece iniciar o Domingo como 1 embora ISO 9889:1999 (o padro C corrente) claramente especificados que ele poderia ser segunda-feira.
	
	%U - dia da semana do ano corrente como nmero decimal, comeando com o primeiro domingo como o primeiro dia da primeira semana
    %V - O nmero da semana corrente ISO 8601:1988 do ano corrente como um nmero decimal, de 01 at 53, onde semana 1  a primeira semana que tem pelo menos 4 dias no ano corrente, e com segunda-feira como o primeiro dia da semana. (Use %G ou %g para o componente anual que corresponde ao dia da semana para o para o timestamp especificado.)
    %W - dia da semana do ano corrente como nmero decimal, comeando com o a segunda-feira como o primeiro dia da primera semana
    %w - dia da semana como nmero decimal, domingo sendo 0
    %x - representao preferida para a data para a localidade corrente sem a hora
    %X - representao preferida para a hora para a localidade corrente sem a data
    %y - ano como nmero decimal sem o sculo (de 00 at 99)
    %Y - ano como nmero decimal incluindo o sculo
    %Z - time zone ou nome or abreviao
    %% - a literal `%' character 

Nota: Note que todas as converses especificadas podem ser suportadas pela sua biblioteca C, em alguns casos elas no sero suportadas pelo PHP strftime(). Alm disso, nem todas as plataformas suportam timestamps negativos, ento sua faixa de datas no pode ser limitada mais cedo do que a poca Unix. Isto significa e.g. %e, %T, %R e %D (e outras mais) e datas anteriores a Jan 1, 1970 no funcionaro em Windows, algumas distribuies Linux, e alguns outros sistemas operacionais. Para sistemas Windows um resumo completo dos especificadores de converso suportados podem ser encontrados neste website MSDN . 

*/
function subtraiDia($data,$dias) 
{
     $ano = substr ( $data, 0, 4 );
     $mes= substr ( $data, 4, 2 );
     $dia=  substr ( $data, 6, 2 );
     $proxdia = mktime ( 0, 0, 0, $mes, $dia - $dias, $ano );
     return strftime("%Y%m%d", $proxdia);
}


$data = date("Ymd");
//$data = "20001231";
echo "Data:  ".$data."<br>";
$proxdata = adicionaDia($data,15);    // Adiciona 15 dias
echo "Data + 15:  ".$proxdata."<br>";
$dataant = subtraiDia($data,30);    // Subtrair 30 dias
echo "Data - 30:  ".$dataant."<br>";




function SomarData($data, $dias, $meses, $ano)
{
   //passe a data no formato dd/mm/yyyy 
   $data = explode("/", $data);
   $novaData = date("d/m/Y", mktime(0, 0, 0, $data[1] + $meses,$data[0] + $dias, $data[2] + $ano) );
   return $novaData;
}
$data = "01/12/0000";
$dias = "01";
$meses = "01"; 
$ano = "1999";
echo SomarData($data, $dias, $meses, $ano);


/* 
Cdigo que seta o fuso horrio do servidor, til para quem utiliza servios de servidores de fora do pas

date_default_timezone_set("Brazil/East");

*/

/*
Exerccio:

Executem os comandos e funes abaixo:

setlocale(LC_TIME, "C");
echo strftime("%A");
setlocale(LC_TIME, "fi_FI");
echo strftime(" in Finnish is %A,");
setlocale(LC_TIME, "fr_FR");
echo strftime(" in French %A and");
setlocale(LC_TIME, "de_DE");
echo strftime(" in German %A.\n");

Este exemplo trabalha se voc tiver as respectivas localidades instaladas em seu sistema.

Nota: %G e %V, que so baseadas nos nmeros de semana no ISO 8601:1988 pode ser dado resultados inesperados (embora corretos) se o sistema numrico no  perfeitamente entendido. Veja %V e o exemplo abaixo. 

Exemplo 2. Exemplo de nmero de semana ISO 8601:1988

 December 2002 / January 2003
ISOWk  M   Tu  W   Thu F   Sa  Su
----- ----------------------------
51     16  17  18  19  20  21  22
52     23  24  25  26  27  28  29
1      30  31   1   2   3   4   5
2       6   7   8   9  10  11  12
3      13  14  15  16  17  18  19   

// Outputs: 12/28/2002 - %V,%G,%Y = 52,2002,2002
echo "12/28/2002 - %V,%G,%Y = " . strftime("%V,%G,%Y", strtotime("12/28/2002")) . "\n";

// Outputs: 12/30/2002 - %V,%G,%Y = 1,2003,2002
echo "12/30/2002 - %V,%G,%Y = " . strftime("%V,%G,%Y", strtotime("12/30/2002")) . "\n";

// Outputs: 1/3/2003 - %V,%G,%Y = 1,2003,2003
echo "1/3/2003 - %V,%G,%Y = " . strftime("%V,%G,%Y",strtotime("1/3/2003")) . "\n";

// Outputs: 1/10/2003 - %V,%G,%Y = 2,2003,2003
echo "1/10/2003 - %V,%G,%Y = " . strftime("%V,%G,%Y",strtotime("1/10/2003")) . "\n";



  December 2004 / January 2005
ISOWk  M   Tu  W   Thu F   Sa  Su
----- ----------------------------
51     13  14  15  16  17  18  19
52     20  21  22  23  24  25  26
53     27  28  29  30  31   1   2
1       3   4   5   6   7   8   9
2      10  11  12  13  14  15  16 

// Outputs: 12/23/2004 - %V,%G,%Y = 52,2004,2004
echo "12/23/2004 - %V,%G,%Y = " . strftime("%V,%G,%Y",strtotime("12/23/2004")) . "\n";

// Outputs: 12/31/2004 - %V,%G,%Y = 53,2004,2004
echo "12/31/2004 - %V,%G,%Y = " . strftime("%V,%G,%Y",strtotime("12/31/2004")) . "\n";

// Outputs: 1/2/2005 - %V,%G,%Y = 53,2004,2005
echo "1/2/2005 - %V,%G,%Y = " . strftime("%V,%G,%Y",strtotime("1/2/2005")) . "\n";

// Outputs: 1/3/2005 - %V,%G,%Y = 1,2005,2005
echo "1/3/2005 - %V,%G,%Y = " . strftime("%V,%G,%Y",strtotime("1/3/2005")) . "\n";

==================================================================================
Criar uma rotina de adiciona dia que tenha como entrada a data e o numero de dias que sero adicionados
- tratar apenas dias teis (nao contar domingos e feriados nacionais)

*/
?>

