<?
//EXPRESES REGULARES - Material retirado do manual oficial PHP


/*
bool ereg ( string expressao, string variavel [, array registros] )

Verifica se a variavel casa com a expresso regular definida em expressao em um modo sensvel a distino de caracteres (case sensitive). 
Se existirem parenteses de substrings na expressao e for passado o terceiro parmetro registros para a funo, a execuo guardar os elementos resultantes na matriz registros. $registros[1] ir conter a substring indicada pelo primeiro parenteses da esquerda; $registros[2] contm a segunda substring, e assim por diante. $registros[0] conter uma cpia completa da variavel casada. 
Nota: Nas verses superiores ao PHP 4.1.0 (inclusive) se voc colocar exatamente dez elementos em $registros, ou at mesmo mais elementos, a expresso ser executada. 
A quantidade no causar efeitos na funo ereg() que tem habilidade de suportar muitas substrings. Se a expresso no casar, $registros no ser alterada por ereg(). 

Retorna TRUE se string casar com pattern, e FALSE se a expresso no casar ou se acontecer algum erro. 
O exemplo seguinte pega uma data no padro ISO (AAAA-MM-DD) e imprime na no formato DD.MM.YYYY 
*/
$data = "2008-03-10";
if (ereg ("([0-9]{4})-([0-9]{1,2})-([0-9]{1,2})", $data, $registros)) {
//([0-9]{4}) os {4} primeiros elementos devem estar compreendidos no intervalo entre 0 e 9,...
/* Como existem () entre os elementos da expresso, estes so passados para o array $registros na ordem em que aparecem, assim $registros[3]recebe o ano,
$registros[2] recebe o mes e $registros[1] o dia
*/
    echo "$registros[3].$registros[2].$registros[1]";
} else {
    echo "Formato de data invlido: $data";
}
echo "<br><br><br>";
/*
bool eregi ( string expressao, string variavel [, array registros] )

Essa funo  idntica a funo ereg() com exceo de no fazer distines alfabticas entre caracteres (case insensitive) na hora de casar resultados. 
*/
$variavel = "Zorro !";
if (eregi("z", $variavel)) {
    echo "A '$variavel' contm a letra 'z' ou 'Z'!";
}
echo "<br><br><br>";
/*
string ereg_replace ( string expressao, string substituicao, string variavel )

Essa funo busca em variavel resultados para a expressao, substituindo se casar pelo texto em substituicao. 
A variavel modificada ser retornada (poder ocorrer da string original ser retornada caso no acontea nenhuma substituio .) 
*/
echo "<br><br><br>";
$string = "Aqui se testa mais algo testa <br>";
echo ereg_replace ("testa ", "testava ", $string);

/*
Preste ateno se usar uma varivel integer no parmetro substituicao, pois o resultado pode no ser exatamente o esperado. 
Isso acontece porque a funo ereg_replace() interpreta o valor ordinal do nmero. Por exemplo: 
Esse exemplo no funcionar. */
$num = 5;
$string = "Essa frase tem cinco palavras<br>";
$string = ereg_replace('cinco', $num, $string);
echo $string;   // Resultado: 'Essa frase tem   palavras.' 

// Esse exemplo funcionar.
$num = '5';
$string = "Essa frase tem cinco  palavras <br>";
$string = ereg_replace('cinco', $num, $string);
echo $string;   // Resultado: 'Essa frase tem 5 palavras.' 
echo "<br><br><br>";

//Exemplo 3. Substitui URLs por links

$text = ereg_replace("[[:alpha:]]+://[^<>[:space:]]+[[:alnum:]/]",
                     "<a href=\"\\0\">\\0</a>", $text);

/*
string eregi_replace ( string expressao, string substituicao, string variavel )
Essa funo  idntica a ereg_replace() com exceo de no fazer distines alfabticas entre caracteres (case insensitive) na hora de casar resultados. 
*/
$string = " o @  usado em endereos de e-mail como rafa@processware.com.br";
echo str_replace ("@", " ARROBA ", $string);

echo "<br><br><br>";


$frase = "voc torce para o Santos de Pel e Robinho." ;
$antigo = array("Santos", "Pel", "Robinho");
$novo = array("Fluzo", "Washington", "Dodo");

$novafrase = str_replace($antigo, $novo, $frase);
echo $novafrase;
echo "<br><br><br>";
// Uso do parmetro count est disponvel no PHP 5.0.0
$str = str_replace("r", "", "O rato roubou o remdio", $count);
echo $count; 
echo "<br><br><br>";

//Expresso regular para validao de e-mail
$email = "email@dominio21.com.br";
$express = "/(\w{3,15})@{1}(\w{2,15})\.com(\.)?(\w{2})?/";
if(preg_match($express,$email,$saida))
{
echo $saida[0];
}
else
{
echo "E-mail invlido";
}
echo "<br><br><br>";

//tel com DDD

$string = "021-2567-4324";
if (preg_match('/^([0-9]{2,3})([-]?[0-9]{4,7})([- ]?[0-9]{4,4})?$/', $string)) {
echo "telefone valido.";
}
else
{
echo "telefone invalido.";
}
echo "<br><br><br>";


//tel sem DDD
$string = "212567-4324";
if (preg_match('/^[0-9]{4,7}([- ]?[0-9]{4,4})?$/', $string)) {
echo "telefone 2 valido.";
}
else
{
echo "telefone 2 invalido.";
}
echo "<br><br><br>";

//URL

$url = "ccccccccccccchttp://www.yart.com.brmnopqrstuvxz";
$validador = "/([http:\/\/]{7})?w{3}\.{1}?[a-z]{3,15}\.[com]{3}(\.)?(\w{2})?/";
preg_match($validador,$url,$vet);
echo $vet[0];

echo "<br><br><br>";



//
$ip = "300.0.0.0";
$teste = "/^(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$/";
if(preg_match($teste,$ip,$res))
{
echo "valida o endereco   ". $res[0];
}
else
{
echo "nao valida o endereco   ". $ip;
}


echo "<br><br><br>";
//Observe que pode-se fazer o mesmo com funes, porm expresses regulares so mais prticas

function ipValida($ip){
if(!eregi("^[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}$", $ip))
return false;
$tmp = explode(".", $ip);
foreach($tmp as $sub){
$sub = $sub * 1;
if($sub<0 || $sub>256) return false;
}
return true;
}
$x="10.0.0.0";
if (ipvalida($x))
{
echo "valida o IP"; 
}
else
{
echo "nao valida o IP";
}

/* Faa uma expresso regular para validao de um CEP (ex:20210-100) e
um CPF(inclusive com a valida	ao lgica dos digitos verificadores) e corrija todas as expresses apresentadas neste documento (elas contem erros de lgica)*/
?>